package ucl.cities.output;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.io.FileUtils;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.engine.environment.RunState;
import ucl.cities.entities.City;

public class Outputter {

	public static int runNumber=0;
	public static Boolean started=false;
	static String seperator=",";
	static String fileName=".."+File.separator+"Cities"+File.separator+"output"+File.separator+"ModelOutput";
//	static String fieldName=".."+File.separator+"Cities"+File.separator+"output"+File.separator+"FieldOutput";
	static String titleLine="Tick,X,Y,Name,Flow,Size,Population";
	static String fieldLine="Tick,X,Y,Name,Flow,Size,Population";
	
//	static Map<Field,Double>flds=new HashMap<Field,Double>();
	
	public static void doOutput(City city){
		List<String>output = new ArrayList<String>();
		String tick=Double.toString(RunEnvironment.getInstance().getCurrentSchedule().
				getTickCount());
		
		String x=Double.toString(city.getOrigX());
		String y=Double.toString(city.getOrigY());
		String name=city.name;
		double flow=city.flowValue;
		double size=city.size;
		int population=city.population;
		if(name.contains(",")){
			name=name.split(",")[0];
		}
		String line=tick+seperator+x+seperator+y+seperator+name+seperator+flow+seperator+size+seperator+population;
		output.add(line);
		writeData(output);
	}
	
	public static void writeData(List<String> lines){
		List<String> oldLines=null;
		double tick=RunEnvironment.getInstance().getCurrentSchedule().getTickCount();
		
		if(tick==0.0 && !started){
			new File(fileName+runNumber+".csv").delete();
			started=true;
		}
		if(new File(fileName+runNumber+".csv").exists() && tick>=0){
			try {
				oldLines=FileUtils.readLines(new File(fileName+runNumber+".csv"));
				oldLines.remove(0);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if(oldLines!=null){
			oldLines.addAll(lines);
			lines=oldLines;
		}
		String fName=fileName;
		try {
			lines.add(0, titleLine);
			FileUtils.writeLines(new File(fName+runNumber+".csv"), lines);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
//		int length=(Integer)RunEnvironment.getInstance().getParameters().getValue("endTick");
//		if(tick==length){
//			lines.remove(0);
//		}
	}
}
