package ucl.cities.style;

import gov.nasa.worldwind.render.Renderable;
import gov.nasa.worldwind.render.SurfacePolygon;
import gov.nasa.worldwind.geom.LatLon;
import gov.nasa.worldwind.layers.Layer;

import java.util.Iterator;

import repast.simphony.visualization.gisnew.GeoShape;
import repast.simphony.visualization.gisnew.NewDisplayGIS;
import repast.simphony.visualization.gisnew.StyledSurfaceShapeLayer;
import repast.simphony.visualization.gisnew.SurfaceCircleShape;
import repast.simphony.visualization.gisnew.SurfacePointShape;
import ucl.cities.entities.City;
import ucl.cities.entities.Location;

public class GShape extends GeoShape{

	public enum FeatureType {MultiPolygon,POINT, LINE, POLYGON, Polygon}
	
	private Renderable renderable;
//	private FeatureType type;

	public Renderable getRenderable() {
		return renderable;
	}
	
	public void setRenderable(Renderable renderable) {
		this.renderable = renderable;
	}
	
	public void setGeometry(Object object){
		if(object instanceof Location){
			Location c = (Location) object;
			SurfacePointShape scs=new SurfaceCircleShape(0.0);
			scs.setLocation(LatLon.fromDegrees(c.getX(), c.getY()));
			this.renderable=scs;
		}
	}
	
	public boolean updateRederable(NewDisplayGIS gis,City field){
		boolean found=false;
		if(this.renderable instanceof SurfacePolygon){
			SurfacePolygon sp = (SurfacePolygon)this.renderable;
			Iterator<Layer> li=
				gis.getWwglCanvas().getModel().getLayers().iterator();
			while(li.hasNext()){
				Layer l = li.next();
				
				if(l.getName().equals("Field")){
					if(l instanceof StyledSurfaceShapeLayer){
						if(((StyledSurfaceShapeLayer)l).getVisualItem(field).equals(this)){
							gis.getWwglCanvas().getModel().getLayers().remove(l);
							found=true;
				//	    gis.getWwglCanvas().getModel().getLayers().add(l);
				//		RenderableLayer rl = new RenderableLayer();
				//		rl.addRenderable(sp);
				//		gis.getWwglCanvas().getModel().getLayers().add(l);
						}
					}
				}
			}
	//		RenderableLayer rl = new RenderableLayer();
	//		rl.addRenderable(sp);
	//		gis.getWwglCanvas().getModel().getLayers()
	//		gis.render();
		}
		return found;
	}

//	public FeatureType getType() {
//		return type;
//	}
//	public void setType(FeatureType type) {
//		this.type = type;
//	}
}